{"openapi":"3.0.1","info":{"title":"TourRadar Partner API","description":"# Overview\n\nWelcome to the TourRadar Partner API documentation!\n\nThe TourRadar Partner API comprises a set of endpoints that can connect any partner to TourRadar’s global network of operators, providing the ability to search, view, and book adventures. You can use TourRadar's entire inventory or only the operators with whom you have direct commercial agreements.\n\nThe API provides a simple and modern REST interface to facilitate the integration work.\n\n> **⚠ Please note:** the work on the API and the integration is still in progress. As the integration work continues, this documentation will be updated as well.\n\n## Who is the API for?\n\nThe current iteration of the API is designed to be used by various types of partners who signed up with TourRadar, partners like OTAs, GDSs, travel content providers, travel agencies, B2B marketplaces.\n\nIf you want to sign up with TourRadar, you can use the following **[link](https://www.tourradar.com/distribution-api)**.\n\n## Typical use cases of the TourRadar Partner API\n\nThe TourRadar Partner API can be used to carry out the following tasks:\n\n### Search for tours\n\nThe **[search endpoint](#tag/Tours/paths/~1v1~1tours~1search/get)** will provide you with the functionality to replicate the filters on the **[TourRadar platform](https://www.tourradar.com/)** and find the right adventure. For an example of the search capabilities, you can look at the filters on the following [page](https://www.tourradar.com/d/europe).\n\n### Get tour details\n\nTo get more information about a tour, you can use the **[tour detail endpoint](#tag/Tours/paths/~1v1~1tours~1{tourId}/get)** – it will return the high-level information with topics like itinerary, what's included and country-specific information.\n\n### Get pricing details and calculate the price\n\nYou can use the **[prices endpoint](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures~1{departureId}~1price/post)** to get more information about the price of a specific departure date but also to understand any other optional extras(e.g. excursions) or accommodations.\n\n### Departures and availability\n\n**[Departures endpoint](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures/get)** retrieves all available departure dates for the specified tour. Every item will contain: departure date, departure type, guide languages offered and the price breakdown. A departure date can be one of the following types: guaranteed, scheduled and request.\n\n### Create booking\n\nYou can create a booking by using the **[bookings endpoint](#tag/Bookings/paths/~1v1~1bookings/post)** and adding all the required entities to the request.\n\n### Check booking status\n\nSome bookings are not automatically confirmed, some are canceled afterwards or declined – so it's useful to retrieve the **[status of a booking](#tag/Bookings/paths/~1v1~1bookings~1{bookingId}~1status/get)**.\n\n### Download bulk data\n\nThere are 2 endpoints that can be used to synchronize content and other data in a “bulk” way:\n**[all tours from an operator](#tag/Bulk/paths/~1v1~1operators~1{operator}~1bulk~1tours/get)** and **[all the available departure dates for all tours from a single tour operator](#tag/Bulk/paths/~1v1~1operators~1{operator}~1bulk~1departures/get)**.\n\nThis data can be downloaded and then imported into the partner’s own database or system. While we recommend updating the departures and availability daily - the tour content can be cached for a longer time (for example, one week).\n\n\n### Booking Retrieval (Fetch)\n\nAgents can use the booking endpoint to retrieve (Fetch) detailed information about bookings directly created on the operator systems. Based on a set of request parameters, the API allows for retrieval of bookings from all operators in the scope of the project, using a uniform request/response schema that is largely based on the Open Travel Alliance standard (OTA).\n\n## Rate limits\n\nA rate limit is a restriction that an API imposes on the number of times a user or client can access the server within a specified period of time. Rate limits are introduced to protect the system from receiving more data than it can handle.\n\nOur API has a rate limit of **10 requests per second**, exceeding this limit will return an error `429 Too Many Requests`.","version":"2025-08-11T15:08:05Z","x-logo":{"url":"https://assets.api.sandbox.b2b.tourradar.com/logo/tourradar.svg","altText":"TourRadar Partner API"}},"servers":[{"url":"https://api.sandbox.b2b.tourradar.com"}],"tags":[{"name":"oAuth 2.0","description":"## POST /oauth2/token\nThe /oauth2/token endpoint only supports HTTPS POST. The partners app client makes requests to this endpoint directly and not through the system browser.\n\nFor more information on the specification see [Token Endpoint](https://openid.net/specs/openid-connect-core-1_0.html#TokenEndpoint).\n\n### Request Parameters in Header\n#### Authorization\nIf the client was issued a secret, the client must pass its client_id and client_secret in the authorization header through [Basic](https://en.wikipedia.org/wiki/Basic_access_authentication#Client_side) HTTP authorization. The secret is Basic Base64Encode(client_id:client_secret).\n\n#### Content-Type\nMust always be `'application/x-www-form-urlencoded'`.\n\n\n### Request Parameters in Body\n\n#### grant_type\nRequired. Grant type. Must be `client_credentials`.\n\n#### scope\nOptional. You can specify a list of scopes (permissions) associated to the authentication token. If not specified, all available permissions will be assigned.\n\nYou should use the `scope` parameter only to restrict permissions for specific usage. If multiple scopes are needed, these must be separated by space.\n\n### Exchanging Client Credentials for an Access Token\n- ClientId:  `7817mgzzf3idtkfekag69udlhr`\n- App Client Secret: `5sg3g3fsase0hlqipp5tv077d5f52g1hh2s7rsvo8hgkdvg`\n- Authorization code: ` Base64Encode(client_id:client_secret)` = `NzgxN21nenpmM2lkdGtmZWthZzY5dWRsaHI6NXNnM2czZnNhc2UwaGxxaXBwNXR2MDc3ZDVmNTJnMWhoMnM3cnN2bzhoZ2tkdmc=`\n\n> **⚠ Please note:** all the above client credentials are just examples. If you do not know the client credentials for your account, please reach out to us and we will share these details with you.\n\n#### Sample Request\n\n```\nPOST https://oauth.api.sandbox.b2b.tourradar.com/oauth2/token >\nContent-Type='application/x-www-form-urlencoded'\nAuthorization=Basic NzgxN21nenpmM2lkdGtmZWthZzY5dWRsaHI6NXNnM2czZnNhc2UwaGxxaXBwNXR2MDc3ZDVmNTJnMWhoMnM3cnN2bzhoZ2tkdmc=\ngrant_type=client_credentials\n```\n\n#### Sample response\n\n```json\nHTTP/1.1 200 OK\nContent-Type: application/json\n\n{\n    access_token: \"eyJraWQiOiJCdHhZVUR4d0k......l4xXhV40gBH6vxvBg\"\n}\n```\n\n> **⚠ Please note:** you are responsible and should take every possible attention to not make your credentials known to anybody else. In particular, if you're developing a website, credentials should not be used in the front-end code of your application. As a general rule, not having hard-coded credentials in the application code is a good practice.\n\n"},{"name":"Versioning","description":"In order to ensure compatibility and consistence of the implemented software with the future development of this API, all endpoints are prefixed with a **version identifier** path component.\n\nThe current version identifier is `v1`. When breaking changes are introduced in an endpoint, a new iteration of that specific endpoint will be created with increased identifier (`v2`, `v3`, etc.), while the existing one will continue working with unchanged request, and response, definition and behaviour.\n\n#### Deprecation Strategy\n\nThe previous version of an API endpoint will be marked as deprecated, and ultimately sunset, over a specified period of time, usually 12 months (unless special business or security requirements demand a different strategy).\n\n#### Example\n\nAll requests to the endpoints present in this documentation will be composed of:\n\n* base URL\n* version identifier\n* endpoint path\n\nFor example, to access the `/bookings/operator/{operator}/{bookingCode}` endpoint in the sandbox environment, the request will be:\n\n* base URL: `https://api.sandbox.b2b.tourradar.com`\n* version identifier: `v1`\n* endpoint path: `/bookings/operator/{operator}/{bookingCode}`\n\nResulting example request path:\n\n```\nGET https://api.sandbox.b2b.tourradar.com/v1/bookings/operator/406/IVSYDS-A339296\n```\n#### Production URLs\n\nOnce you are ready to go live, please use the following production URLs:\n\n* API base URL: `https://api.b2b.tourradar.com`\n* OAuth URL: `https://oauth.api.sandbox.b2b.tourradar.com/oauth2/token`\n"},{"name":"Error Codes","description":"| Error code | Service | Meaning |\n| ------ | ----- | ----- |\n| `ACCESS_DENIED` | _All_ | Authentication is not valid |\n| `BAD_REQUEST_PARAMETERS` | _All_ | The request parameters are invalid |\n| `BAD_REQUEST_BODY` | _All_ | The body of the request is invalid |\n| `BOOKING_NOT_CREATED` | _All_ | The booking could not be created |\n| `BOOKING_NOT_CONFIRMED` | _All_ | The booking could not be confirmed |\n| `BOOKING_NOT_DECLINED` | _All_ | The booking could not be declined |\n| `BOOKING_NOT_FOUND` | **[/booking/{operator}/{bookingCode}](#tag/Bookings/paths/~1v1~1bookings~1{operator}~1{bookingCode}/get)** | Booking not found |\n| `DEPARTURE_UNAVAILABLE` | _All_ | The booked departure is not available |\n| `DEPARTURE_NOT_FOUND` | **[/tours/{tourId}/departures/{departureId}](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures~1{departureId}/get)** | Departure could not be found |\n| `EXPIRED_TOKEN` | _All_ | The authentication token is not valid anymore |\n| `HOLD_NOT_CREATED` | _All_ | The hold could not be created |\n| `INVALID_API_KEY` | _All_ | Authentication is not valid |\n| `INVALID_CLIENT` | **[/oauth2/token](#tag/oAuth-2.0)** | Invalid client id provided |\n| `INVALID_REQUEST` | _All_ | Operation not supported |\n| `INVALID_SIGNATURE` | _All_ | Authentication is not valid |\n| `INVALID_SCOPE` | **[/oauth2/token](#tag/oAuth-2.0)** | Invalid scope provided |\n| `MISSING_AUTHENTICATION_TOKEN` | _All_ | Authentication is not valid |\n| `NOT_FOUND` | _All_ | Resource not found |\n| `OPERATOR_NOT_FOUND` | **[/booking/{operator}/{bookingCode}](#tag/Bookings/paths/~1v1~1bookings~1{operator}~1{bookingCode}/get)** | Invalid operator name |\n| `OPERATOR_TIMEOUT` | **[/bookings](#tag/Bookings/paths/~1v1~1bookings/get)** | The request to the operator has timed out |\n| `QUOTA_EXCEEDED` | _All_ | Too many requests have been made |\n| `REQUEST_FAILED` |  **[/booking/{operator}/{bookingCode}](#tag/Bookings/paths/~1v1~1bookings~1{operator}~1{bookingCode}/get)**  | Operator server failure |\n| `REQUEST_TIMEOUT` | _All_ | Request took too long |\n| `REQUEST_TOO_LARGE` | _All_ | The maximum size for a request has been exceeded |\n| `RESOURCE_NOT_FOUND` | _All_ | The API endpoint URL is incorrect |\n| `TOO_MANY_REQUESTS` | _All_ | Too many requests have been made in a given amount of time |\n| `TOUR_NOT_ACTIVE` | **[/tours/{tourId}/departures](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures/get)** | Tour is not active |\n| `TOUR_NOT_FOUND` | **[/tours/{tourId}](#tag/Tours/paths/~1v1~1tours~1{tourId}/get)** | Tour could not be found |\n| `UNAUTHORIZED` | **[/booking/{operator}/{bookingCode}](#tag/Bookings/paths/~1v1~1bookings~1{operator}~1{bookingCode}/get)** | Invalid operator credentials |\n| `UNAUTHORIZED_CLIENT` | **[/oauth2/token](#tag/oAuth-2.0)** | Invalid client credentials |\n| `UNKNOWN_ERROR` | _All_ | Server failure or unexpected error condition |\n| `UNSUPPORTED_MEDIA_TYPE` | _All_ | The media attached to the request is not supported |\n| `VALIDATION_ERROR` | _All_ | Parameter missing or invalid |\n"},{"name":"Taxonomy","description":""},{"name":"Operators","description":""},{"name":"Tours","description":""},{"name":"Pricing & Availability","description":""},{"name":"Bookings","description":""},{"name":"Bulk","description":""}],"paths":{"/v1/bookings":{"get":{"tags":["Bookings"],"summary":"/v1/bookings","description":"Returns a list of all the bookings created in the TourRadar system by your partner account.\n\n#### Response formats\n\nYou can set the `Accept` header to define the response format you need.\nThe available values are:\n- `application/json` (default). It will return an array of **BookingSearch** objects;\n\n- `text/csv`, if this format is requested the `limit` query parameter is ignored. It will contain these fields:\n\n| field         | type    | notes |\n| ---------------   | ------- | ----- |\n| booking_id        | integer | Unique identifier of the booking in the TourRadar system. |\n| tour_id           | integer | Unique identifier for the tour in the TourRadar system. |\n| tour_name         | string  | Name of the tour. |\n| operator_id       | integer | Unique identifier for the tour operator in the TourRadar system.  |\n| operator_name     | string  | Name of the tour operator. |\n| tour_length_days  | integer | Length of the tour, expressed in number of days. |\n| passengers        | integer | Number of passengers. |\n| departure_date    | string  | Departure date that was booked, in the format `YYYY-MM-DD`. |\n| return_date       | string  | Return date that was booked, in the format `YYYY-MM-DD`. |\n| created_at        | string  | Exact timestamp of when the booking was created, in the ISO 8601 format. |\n| confirmed_at      | string  | Exact timestamp of when the booking was confirmed, in the ISO 8601 format. Empty if it is not confirmed. |\n| hold_expire_at    | string  | Exact timestamp of when the the hold will expire, in the ISO 8601 format. |\n| type              | string  | Type of this booking record. Expected values: `booking`, `question`, `hold`. |\n| status            | string  | Status of the booking. Expected values: `open_question`, `open_hold`, `pending`, `confirmed`, `declined`, `cancelled`, `hold_expired`, `hold_declined` |\n| currency          | string  | Currency of the booking. |\n| total_value       | number  | Total amount of the booking. |","parameters":[{"name":"sort_by","in":"query","description":"Field by which the results will be sorted. Possible values: `id`, `departure_date`,  `created_at`, `status`. Default is `id`.","schema":{"type":"string"}},{"name":"Accept","in":"header","description":"Defines the response format. Current available values are `application/json` and `text/csv`.","schema":{"type":"string"}},{"name":"updated_range","in":"query","description":"Get the bookings that are updated in a certain date range. Valid formats are: `YYYYMMDD-YYYYMMDD` and `YYYYMMDD`. Using the single date format, it will retrieve the bookings updated in that day.","schema":{"type":"string"}},{"name":"limit","in":"query","description":"Number of items per page of results (default is 20, max 100).","schema":{"type":"string"}},{"name":"Accept-Language","in":"header","description":"Defines in which language the resources are returned. Use ISO-639 language or locale codes (example: `en`, `en-US`).","schema":{"type":"string"}},{"name":"agent_id","in":"query","description":"Filter bookings by agent id.","schema":{"type":"string"}},{"name":"page","in":"query","description":"Number of page to return (default is 1).","schema":{"type":"string"}},{"name":"sort_order","in":"query","description":"Direction of the sorting (ascending or descending). Possible values: `asc`, `desc`.","schema":{"type":"string"}},{"name":"date_range","in":"query","description":"Date range in which to search for bookings. Valid formats are: `YYYYMMDD-YYYYMMDD` and `YYYYMMDD`. Using the single date format, it will retrieve the bookings created in that day.","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BookingSearchPagination"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.bookings/read"]}]},"post":{"tags":["Bookings"],"summary":"/v1/bookings","description":"Creates a booking in the TourRadar system.\n\nThe payload must be sent as JSON in the request body.\nThe required entries are:\n\n* `departure_id`: this is the unique identifier of the wanted departure date for the desired tour. To retrieve departure dates, use the **[/tours/{tourId}/departures](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures/get)** endpoint.\n* `currency`: the currency that will be used for payments.\n* `passengers`: the list of passengers in the booking.\n* `email`: email used for communications regarding the booking (partner support email). Please be aware that this email is different than the one from passengers definition.\n\nFurthermore, it's possible to add the following sections, if needed:\n\n* `accommodations`: defines the desired accommodation types (if the tour offers them), and which passengers will use them.\n* `optional_extras`: optional extra items that can be booked together with the tour.\n\nThis is an example of how the payload for a booking looks like:\n\n```json\n{\n  \"departure_id\": 123,\n  \"currency\": \"EUR\",\n  \"email\": \"dummy@mail.org\",\n  \"passengers\": [\n    {\n      \"pax_number\": 1,\n      \"price_category_id\": 1,\n      \"fields\" : {\n        \"first_name\": \"John\",\n        \"last_name\": \"Doe\",\n        \"email\": \"dummy@mail.org\",\n        \"phone_number\": \"+431245678853\",\n        \"date_of_birth\": \"21/05/2019\",\n        \"nationality\": \"Germany\",\n        \"gender\": \"male\"\n      }\n    },\n    {\n      \"pax_number\": 2,\n      \"price_category_id\": 2,\n      \"fields\" : {\n        \"first_name\": \"John\",\n        \"last_name\": \"Doe\",\n        \"email\": \"dummy@mail.org\",\n        \"phone_number\": \"+431245678853\",\n        \"date_of_birth\": \"21/05/2019\",\n        \"nationality\": \"Germany\",\n        \"gender\": \"female\"\n      }\n    }\n  ],\n  \"accommodations\": [\n    {\n      \"id\": 345,\n      \"passengers\": [1, 2]\n    }\n  ],\n  \"optional_extras\": [\n    {\n      \"id\": 456,\n      \"passengers\": [2]\n    }\n  ],\n}\n```\n\n#### Passengers definition\n\nFor each entry in the `passengers` array, these are the required fields:\n\n* `pax_number`: this is the index of the passenger, starting with 1. The passenger number will be used in the accommodation and extras sections of the request, to assign specific passengers to elements of the booking.\n* `price_category_id`: this defines the category of the passenger. To retrieve price categories, use the **[/tours/{tourId}/prices](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1prices/get)** endpoint.\n* `fields`: this is the passenger information, as requested by the operator. To retrieve a list of fields, and if they are required or optional, use the **[/operator/{operatorId}/booking-fields](#tag/Operators/paths/~1v1~1operators~1{operator}~1booking-fields/get)** endpoint. Some examples of these fields:\n  * `title`: title of the passenger, possible values: `Mr.`, `Ms.`, `Mrs.`, `Miss`.\n  * `gender`: gender of the passenger, possible values: `male`, `female`.\n  * `date_of_birth`: date of birth of the passenger, format needed: `DD/MM/YYYY`.\n  * `email`: the passenger's email address.\n  * `bed_preference`: the passenger's bed preference, possible values: `Single Bed`, `Twin Bed`.\n  * `nationality`: nationality of the passenger, please use country names from the taxonomy endpoint **[/taxonomy/destinations/country](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)**, some examples: `Argentina`, `Austria`, `Bahrain`, `Belgium`, `Australia`. \n\n\n#### Accommodation\n\nIn the `accommodations` section, it's possible to specify the identifier of an accommodation option, and which passenger numbers should make use of it.\n\nTo retrieve a list of accommodation options available for the desired departure, use the **[/tours/{tourId}/departures/{departureId}](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures~1{departureId}/get)** endpoint.\n\n#### Optional extras\n\nThe `optional_extras` section works exactly like the `accommodations` section.\n\nTo retrieve a list of the optional extra items available for the desired departure, use the **[/tours/{tourId}/departures/{departureId}](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures~1{departureId}/get)** endpoint.\n\n#### Booking conversation page\n\nAfter the creation of the booking, you will receive in the response a link that leads to the booking conversation page. The link will be available in the `links` object in the response and it will have the type `booking-page`. This page is where all the communication happens between travelers and TourRadar, or the adventure operator. It shows details about the tour booked and has a price breakdown.\n\nAn example of a booking conversation page link is:\n\n```json\n  \"links\": [\n    {\n      \"type\": \"booking-page\",\n      \"url\": \"https://www.tourradar.com/booking/12345?enquiryCode=fvwffws8hgqqz4blyh13icbyldjqhp6d\"\n    }\n  ],\n```\n\n#### Additional information\n\nIn the request, it is possible to add these additional fields:\n\n* `partner_booking_code`: the booking code, or reference number, in your system. This will be stored with the booking, and returned with the booking detail request (**[/bookings/{bookingId}](#tag/Bookings/paths/~1v1~1bookings~1{bookingId}/get)** endpoint).\n* `store_id`: this is the name or identifier of the store, or agent, that made the booking. It will also be stored and returned.\n* `custom_data`: an object containing additional info from your side, stored and retrieved too. Up to 5 string properties can be set in it.\n\n#### Testing payments\n\nIn our sandbox environment, you can use one of the Braintree test credit cards. More information about this can be found **[here](https://developer.paypal.com/braintree/docs/reference/general/testing#valid-card-numbers)**.\n\nPlease be aware that using one of these valid card numbers does not necessarily mean that the transaction will be successful in the sandbox environment. For example, a transaction with amount between 2000-2999 will cause a payment failure. All the details about transaction amounts and responses can be found **[here](https://developer.paypal.com/braintree/docs/reference/general/testing#transaction-amounts)**.\n\n\n#### Pending status reason\n\nIf there were some errors on the operator side when a booking is created, that booking will have the pending status and the error message received from the operator stored in the field called `status_reason_text`.\nBelow, you will find an example of this situation:\n\n```json\n{\n  ...\n  \"status\": \"pending\",\n  \"status_reason\": \"BOOKING_NOT_CONFIRMED\",\n  \"status_reason_text\": \"Booking could not be confirmed - Missing mandatory fields\"\n}\n```\n\nThese fields can be used to understand why there was a problem with the booking and can be leveraged by your CS team to try and make the booking confirmed.\n","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BookingInput"}}},"required":true},"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Booking"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.bookings/write"]}]}},"/v1/bookings/affiliate":{"get":{"tags":["Bookings"],"summary":"/v1/bookings/affiliate","description":"Booking listing endpoint - list only bookings created by affiliate partner. This endpoint have limited amount of exposed data.","parameters":[{"name":"sort_by","in":"query","description":"Field by which the results will be sorted. Possible values: `id`, `departure_date`,  `created_at`, `status`. Default is `id`.","schema":{"type":"string"}},{"name":"Accept","in":"header","description":"Defines the response format. Current available values are `application/json` and `text/csv`.","schema":{"type":"string"}},{"name":"updated_range","in":"query","description":"Get the bookings that are updated in a certain date range. Valid formats are: `YYYYMMDD-YYYYMMDD` and `YYYYMMDD`. Using the single date format, it will retrieve the bookings updated in that day.","schema":{"type":"string"}},{"name":"limit","in":"query","description":"Number of items per page of results (default is 20, max 100).","schema":{"type":"string"}},{"name":"Accept-Language","in":"header","description":"Defines in which language the resources are returned. Use ISO-639 language or locale codes (example: `en`, `en-US`).","schema":{"type":"string"}},{"name":"page","in":"query","description":"Number of page to return (default is 1).","schema":{"type":"string"}},{"name":"sort_order","in":"query","description":"Direction of the sorting (ascending or descending). Possible values: `asc`, `desc`.","schema":{"type":"string"}},{"name":"date_range","in":"query","description":"Date range in which to search for bookings. Valid formats are: `YYYYMMDD-YYYYMMDD` and `YYYYMMDD`. Using the single date format, it will retrieve the bookings created in that day.","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BookingSearchPagination"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.bookings.affiliate/read"]}]}},"/v1/bookings/operator/{operator}/{bookingCode}":{"get":{"tags":["Bookings"],"summary":"/v1/bookings/operator/{operator}/{bookingCode}","description":"\nThis endpoint returns detailed information about a booking, retrieved directly from the operator system.\n\nThe call expects two parameters as part of the request path:\n\n- the operator ID\n- the booking code (in the operator system)\n\nAdditionally, the following query string parameters are supported:\n\n- `currency`: the currency in which the booking was made (use 3-letter ISO 4217 codes, for example `USD` for US Dollars)\n- `surname`: the last name of one passenger in the booking\n- `next_id`: if the booking has multiple tours, the index of the tour to retrieve\n\nThe parameters `currency` and `surname` are required by some operators in order to successfully retrieve a booking.\n\nA full example of a call to this endpoint could be:\n\n```\nGET /bookings/operator/406/IVSYDS-A339296?surname=Davis&currency=USD\n```\n\nAdditional parameters may be added in a future revision, for example the identifier of the agent (store ID) who made the booking.\n\n#### Retrieving operator ID\n\nTo retrieve the operator ID for a specific operator, it's possible to use the call [/operators](#tag/Operators/paths/~1v1~1operators/get), which will return a list of all available operators with ID, name, and code.\n\n#### Output definition\n\nThe output format is JSON, and the data structure follows closely the OTA standard. In particular, the response is based on the [OTA_TourActivityBookRS.ReservationDetails schema](https://modelviewers.pilotfishtechnology.com/modelviewers/OTA/model/Format.OTA_TourActivityBookRS.ReservationDetails.html).\n\nUnlike OTA, identifiers use the `snake_case` (lowercase, underscore between words) notation, instead of `PascalCase` (first letter of each word capitalized). Furthermore, some fields have been added to the existing schema to support the variety of data returned by operators.\n\nIt should be noted that not all operators return all information for bookings. Where possible, data have been structured to minimize the difference between different operators' implementations. The list of fields provided by **all operators** is defined as follows:\n\n| object | field | notes |\n| ------ | ----- | ----- |\n| confirmation | id | |\n| confirmation | status | |\n| basic_info | name | Name of the tour/activity |\n| basic_info | tour_activity_id | Operator code of the tour/activity |\n| schedule | duration | |\n| schedule | start | |\n| schedule | end | |\n| participant_info.individual | given_name | |\n| participant_info.individual | surname | |\n| participant_info.individual | birth_date | |\n| pricing.summary | amount | |\n| commission_info | commission_payable_amount | |\n\n> ⚠ **WARNING**: the list is not final in this version\n\n#### Error codes\n\nEvery failed request will result in a HTTP status code in the 400 or 500 range. The JSON element `error` in the response will identify the error condition.\n\nThis is a list of the possible error codes returned by this API:\n\n| Error code | HTTP Status code | Meaning |\n| ------ | ----- | ----- |\n| `UNAUTHORIZED` | 401 | Invalid operator credentials |\n| `BOOKING_NOT_FOUND` | 404 | Booking not found |\n| `OPERATOR_NOT_FOUND` | 412 | Invalid operator ID |\n| `INVALID_REQUEST` | 405 | Operation not supported |\n| `VALIDATION_ERROR` | 422 | Parameter missing or invalid |\n| `UNKNOWN_ERROR` | 500 | Server failure or unexpected error condition |\n| `REQUEST_FAILED` | 502 | Operator server failure |\n\n#### Booking status\n\nThe booking status (response field `booking.status`) from different operators is mapped to one of the following values:\n\n- `pending`: the booking has not been confirmed yet\n- `confirmed`: the booking has been confirmed\n- `declined`: the booking has been cancelled by the operator\n- `cancelled`: the booking has been cancelled by the customer or agent\n\nIn the event of a status response not recognised by the system, this field will contain `unknown`.\nIn this case, another response field `booking.operator_status` will contain the original status information provided by the operator.\n\n#### Bookings with multiple tours\n\nSome operators include several tours/activities inside the same booking. In this case, a call to the booking code will return only the first tour/activity (together with their extras, payment information, and so on).\n\nThe response, however, will contain an attribute `next_id`, whose value can be added to the query parameters in order to retrieve the next tour/activity in the booking.\n\nThe call can be repeated as long as the attribute `next_id` in the response has a value, to get additional components of the booking. When the attribute `next_id` doesn't have a value, the last of the tours/activities in this booking has been reached.\n\n##### Example:\n\nFirst request:\n\n```\nGET /bookings/operator/204/6180043\n```\n\nResponse:\n\n```\n{\n    \"reservation_details\": {\n        \"basic_info\": {\n            \"name\": \"4WD Broome to Darwin Overland\",\n            ....\n        }\n    },\n    \"next_id\": \"1\"\n}\n```\n\nThe value `1` for the attribute `next_id` means that there is another component in the same booking, so we can perform the second request:\n\n```\nGET /bookings/operator/204/6180043?next_id=1\n```\n\nResponse:\n\n```\n{\n    \"reservation_details\": {\n        \"basic_info\": {\n            \"name\": \"Kakadu, Katherine & Litchfield Adventure\",\n            ....\n        }\n    }\n}\n```\n\nThis time, the response doesn't contain a `next_id` attribute, which means this booking only has 2 tours/activities in it.\n","parameters":[{"name":"bookingCode","in":"path","description":"Operator's unique booking code (note: special characters must be URL-encoded)","required":true,"schema":{"type":"string"}},{"name":"currency","in":"query","schema":{"type":"string"}},{"name":"operator","in":"path","description":"Operator ID","required":true,"schema":{"type":"string"}},{"name":"surname","in":"query","schema":{"type":"string"}},{"name":"next_id","in":"query","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BookingResponse"}}}},"401":{"description":"This status code indicates that the credentials used for the fetch request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- wrong configuration\n- outdated operator credentials\n","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["UNAUTHORIZED","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"404":{"description":"This status code indicates that the operator or booking was not found.\n\nThe error code is `BOOKING_NOT_FOUND` or `OPERATOR_NOT_FOUND`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- the booking code is invalid\n- one of the required parameters (surname, currency, etc.) is wrong\n- the operator parameter is wrong\n","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["OPERATOR_NOT_FOUND","BOOKING_NOT_FOUND","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"405":{"description":"This status code indicates that the operation is not supported for the given operator.\n\nThe error code is `INVALID_REQUEST`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- the operator doesn't support booking creation\n- the operator id is not integer\n","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["INVALID_REQUEST","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"422":{"description":"This status code indicates that there was a validation error in the request parameters.\n\nThe error code is `VALIDATION_ERROR`. An additional `validation_errors` element will list all the parameters which were invalid.\n\nCauses for this error may be:\n\n- required parameters are missing\n- some parameters have the wrong type\n","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["VALIDATION_ERROR","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}},"502":{"description":"This status code indicates that there was a failure on the operator's system.\n\nThe error code is `REQUEST_FAILED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- network connectivity issue to the operator's system\n- operator's system failing\n- operator's system responding with an invalid response","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["REQUEST_FAILED","OPERATOR_TIMEOUT","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}}},"security":[{"application":["com.tourradar.bookings/read"]}]}},"/v1/bookings/{bookingId}":{"get":{"tags":["Bookings"],"summary":"/v1/bookings/{bookingId}","description":"Retrieves details about a booking created in the TourRadar system.\n\n","parameters":[{"name":"bookingId","in":"path","description":"Booking ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Booking"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.bookings/read"]}]}},"/v1/bookings/{bookingId}/status":{"get":{"tags":["Bookings"],"summary":"/v1/bookings/{bookingId}/status","description":"Retrieves the status of a booking created in the TourRadar system.\n\nTo get the full details about a booking, use the **[/bookings/{bookingId}](#tag/Bookings/paths/~1v1~1bookings~1{bookingId}/get)** endpoint.\n\nThe primary scope of this endpoint is to check the status of a `pending` booking, to verify if it has been confirmed by the operator.\n\n","parameters":[{"name":"bookingId","in":"path","description":"Booking ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BookingStatus"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.bookings/read"]}]}},"/v1/operators":{"get":{"tags":["Operators"],"summary":"/v1/operators","description":"Returns a list of all operators for which the TourRadar system has content, or can retrieve bookings.\n","responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/OperatorList"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.operators/read"]}]}},"/v1/operators/{operator}":{"get":{"tags":["Operators"],"summary":"/v1/operators/{operator}","description":"This endpoint can be used to retrieve information about a single operator.\n\n#### Terms and conditions of each operator\n\nThe endpoint contains information about terms and conditions for each operator (if they are available) in the following 2 fields:\n\n* `terms_text`: full text for the terms and conditions of the operator (please be aware that it may contain HTML).\n* `terms_url`: link to the terms and conditions page from the operator website, if available.\n\nPlease see below an example of a response from this endpoint:\n```json\n{\n    \"id\": 9,\n    \"name\": \"Contiki\",\n    \"code\": \"contiki\",\n    \"terms_text\": \"This is an example of terms and conditions for the operator Contiki.\",\n    \"has_integration\": true,\n    \"terms_url\": \"http://www.contiki.com/booking-conditions\"\n}\n```\n","parameters":[{"name":"operator","in":"path","description":"Operator integer ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Operator"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.operators/read"]}]}},"/v1/operators/{operator}/booking-fields":{"get":{"tags":["Operators"],"summary":"/v1/operators/{operator}/booking-fields","description":"Retrieve booking fields for this operator.\n\nThis is the list of fields that will need to be passed to the create booking request (**[/bookings](#)**). For each field, the name, label, group, and value type are returned.\n\n#### Mandatory fields\n\nSome operators have their own requirements about which fields are considered mandatory, and which are optional.\n\nFurthermore, fields can be mandatory for the lead passenger (the first passenger in the booking), but not for additional passengers. Two fields in the response define if a field is mandatory or not: `main_pax` and `additional_pax`.\n\nThe possible values for those fields are:\n\n* `mandatory`: the field is always mandatory, booking will fail if the field is not provided.\n* `optional`: the field is always optional.\n* `mandatory_post_booking`: the field is optional to create a booking, but will have to be provided to the operator before the tour's departure date (examples of such fields may include passport number, proof of insurance, etc.).\n\n","parameters":[{"name":"operator","in":"path","description":"Operator integer ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/BookingFields"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.operators/read"]}]}},"/v1/operators/{operator}/bulk/departures":{"get":{"tags":["Bulk"],"summary":"/v1/operators/{operator}/bulk/departures","description":"Downloads an operator's available departure dates in bulk.\n\nThis endpoint is supposed to be used to download large amount of data, and import them into the partner's own database or system for faster access.\n\nThe response of this endpoint will be a list of URLs.\nEach one of them points to a (gzip-compressed) JSON file containing up to 500 tours.\nFor each tour, all available departure dates will be listed. \n\nThe URLs are signed for download, and are only valid for a limited amount of time (10 minutes).\nAfter the expiration, the links will not be valid anymore, and a new request to this endpoint has to be made to obtain new download links.\n\nAn example of the response for this call could be:\n\n```json\n{\n  \"urls\": [\n    \"https://s3.us-east-1.amazonaws.com/tour-inventory.b2b.tourradar.com/bulk_data/operators/operator_id%3D204/locale_id%3D1/tour_departures.2021-11-03.13-29-08.229377.0.json.gz?X-Amz-Algorithm=AWS4-HMAC-SHA256[...]&x-id=GetObject\",\n    \"https://s3.us-east-1.amazonaws.com/tour-inventory.b2b.tourradar.com/bulk_data/operators/operator_id%3D204/locale_id%3D1/tour_departures.2021-11-03.13-29-08.229377.1.json.gz?X-Amz-Algorithm=AWS4-HMAC-SHA256[...]x-id=GetObject\",\n    \"https://s3.us-east-1.amazonaws.com/tour-inventory.b2b.tourradar.com/bulk_data/operators/operator_id%3D204/locale_id%3D1/tour_departures.2021-11-03.13-29-08.229377.2.json.gz?X-Amz-Algorithm=AWS4-HMAC-SHA256[...]&x-id=GetObject\"\n  ],\n  \"expires_in\": 600\n}\n```\n\nThe content of the files that will be downloaded will look like this:\n\n```json\n[\n  {\n    \"tour_id\": 1492,\n    \"departure_dates\": [\n      {\n        \"id\": 722685916,\n        \"date\": \"2022-05-07\",\n        \"type\": \"scheduled\",\n        \"guide_languages\": [\n          1\n        ]\n      },\n      {\n        \"id\": 722685917,\n        \"date\": \"2022-05-21\",\n        \"type\": \"scheduled\",\n        \"guide_languages\": [\n          1\n        ]\n      }\n    ]\n  },\n  {\n    \"tour_id\": 1493,\n    \"departure_dates\": [\n      {\n        \"id\": 722685694,\n        \"date\": \"2022-04-23\",\n        \"type\": \"scheduled\",\n        \"guide_languages\": [\n          1\n        ]\n      }\n    ]\n  }\n]\n```\n\nFor each departure, the file contains the identifier, date, type, and languages the tour is offered in.\nThose data are the same available in the **[tours/{tourId}/departures](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures/get)** endpoint.\n\nBulk data is updated regularly at least once per day (schedule may vary for different operators).","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"operator","in":"path","description":"Operator integer ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/OperatorBulkFiles"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"404 response","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["UNKNOWN_ERROR","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.operators/read"]}]}},"/v1/operators/{operator}/bulk/tours":{"get":{"tags":["Bulk"],"summary":"/v1/operators/{operator}/bulk/tours","description":"Downloads an operator's tour data in bulk.\n\nThis endpoint is supposed to be used to download large amount of data, and import them into the partner's own database or system for faster access.\n\nThe response of this endpoint will be a list of URLs.\nEach one of them points to a (gzip-compressed) JSON file containing up to 500 tours.\nThe schema for each tour is exactly the one used in the **[/tours/{tourId}](#tag/Tours/paths/~1v1~1tours~1{tourId}/get)** endpoint.\n\nThe URLs are signed for download, and are only valid for a limited amount of time (10 minutes).\nAfter the expiration, the links will not be valid anymore, and a new request to this endpoint has to be made to obtain new download links.\n\nAn example of the response for this call could be:\n\n```json\n{\n  \"urls\": [\n    \"https://s3.us-east-1.amazonaws.com/tour-inventory.b2b.tourradar.com/bulk_data/operators/operator_id%3D204/locale_id%3D1/tour_data.2021-11-03.13-29-08.229377.0.json.gz?X-Amz-Algorithm=AWS4-HMAC-SHA256[...]&x-id=GetObject\",\n    \"https://s3.us-east-1.amazonaws.com/tour-inventory.b2b.tourradar.com/bulk_data/operators/operator_id%3D204/locale_id%3D1/tour_data.2021-11-03.13-29-08.229377.1.json.gz?X-Amz-Algorithm=AWS4-HMAC-SHA256[...]x-id=GetObject\",\n    \"https://s3.us-east-1.amazonaws.com/tour-inventory.b2b.tourradar.com/bulk_data/operators/operator_id%3D204/locale_id%3D1/tour_data.2021-11-03.13-29-08.229377.2.json.gz?X-Amz-Algorithm=AWS4-HMAC-SHA256[...]&x-id=GetObject\"\n  ],\n  \"expires_in\": 600\n}\n```\n\nBulk data is updated regularly at least once per day (schedule may vary for different operators).","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"operator","in":"path","description":"Operator integer ID","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/OperatorBulkFiles"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"404 response","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["UNKNOWN_ERROR","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.operators/read"]}]}},"/v1/taxonomy/currencies":{"get":{"tags":["Taxonomy"],"summary":"/v1/taxonomy/currencies","description":"This endpoint returns the list of all currencies supported by the TourRadar system.\n\nThe following attributes will be returned for each item:\n\n- `code`: three-letter currency code in the ISO 4217 format.\n- `name`: name of the currency.\n- `symbol`: short symbol used to describe the currency in reference to amounts of money (example: `€` for Euro).\n","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TaxonomyCurrenciesList"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":[]}]}},"/v1/taxonomy/destinations/{type}":{"get":{"tags":["Taxonomy"],"summary":"/v1/taxonomy/destinations/{type}","description":"This endpoint returns a list of all destinations in the TourRadar system.\n\nEach destination type can be requested. \n\nThese are the available query parameters:\n- `country_id`: filter destinations by country ID. It can be a single integer or a comma-separated list of integers. It is available for all types but country and continent. E.g. `?country_id=1,2,3`\n\nIn general, the following attributes will be returned:\n\n- `id`: this is the unique identifier of this destination in the system. The value is immutable, and can be used to setup a mapping between TourRadar destination and the partner's own destinations, or in search requests where a destination ID is needed.\n- `name`: the name of the destination.\n- `parent_ids`: unique identifiers of this destination's parent destinations. Usually, this will be one value; for example, cities have a state ID as parent, states have a country ID as parent, and so on. There are destination types, for example rivers or national parks, that can belong to more than one country.\n- `latitude` and `longitude`: coordinates of the destination. This mostly applies to countries, states, and cities. Other types may not have geographical information.\n- `geoname_id`: available for countries and cities, this is the identifier of the destination in the GeoNames geographical database (http://www.geonames.org/). The identifier can be used to facilitate the mapping. *Note*: not 100% of the entries are mapped to a GeoNames entity. TourRadar is committed to constantly improve the data quality, but can't guarantee a perfect match all of the times.\n- `country_id`: available for all types but country and continent, this is the identifier of the country the destination belongs to.\n\nIn addition, countries have the following additional information:\n\n- `country_code`: two-letter country code in the ISO 3316-1 alpha-2 format.\n- `currency_code`: three-letter currency code used in the country in the ISO 4217 format.\n- `currency_name`: name of the currency used in the country.\n- `electricity_outlets`: an array of one-letter electrical plug types used in the country, as defined by IEC (https://www.iec.ch/world-plugs).\n\nResults will be paginated (1000 elements at a time). If the response contains the `next_page` element, it's possible to access the next 1000 elements by repeating the request with the `page` parameter.\n\nExample: `/v1/taxonomy/destinations/city?page=2`\n\n\n","parameters":[{"name":"type","in":"path","description":"Possible values: \n`continent`, \n`country`,\n`state`,\n`region`,\n`city`,\n`national-park`,\n`island`,\n`mountain`,\n`ocean`,\n`river`,\n`lake`\n","required":true,"schema":{"type":"string"}},{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"country_id","in":"query","schema":{"type":"string"}},{"name":"limit","in":"query","schema":{"type":"string"}},{"name":"page","in":"query","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TaxonomyDestinationPagination"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"422":{"description":"destination type not found.","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["VALIDATION_ERROR","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":[]}]}},"/v1/taxonomy/languages":{"get":{"tags":["Taxonomy"],"summary":"/v1/taxonomy/languages","description":"This endpoint returns the list of all guided languages of the tours from TourRadar system.\n\nThe following attributes will be returned for each item:\n\n- `id`: this is the unique identifier of this language in the system.\n- `code`: 2-letter language code in the ISO 639-1 standard.\n- `name`: name of the language.\n","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TaxonomyLanguagesList"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":[]}]}},"/v1/taxonomy/tours/types":{"get":{"tags":["Taxonomy"],"summary":"/v1/taxonomy/tours/types","description":"This endpoint returns a list of all tour types supported by the TourRadar system.\n\nTour types are categories associated to a tour. One tour can belong to different categories. Furthermore, tour types are organized in groups.\n\nThe following attributes will be returned for each item:\n\n- `id`: this is the unique identifier of the type in the system. It can be used in a search request when a tour type ID is needed.\n- `name`: name of the tour type.\n- `group_id`: unique identifier of the group this tour type belongs to.\n- `group_name`: name of the group this tour type belongs to.\n","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TaxonomyToursTypesList"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":[]}]}},"/v1/tours/search":{"get":{"tags":["Tours"],"summary":"/v1/tours/search","description":"\nReturns a list of tours based on a number of search criteria.\n\n#### Search parameters\n\nThe call has a number of optional parameters, that will help you find the perfect tour for your customer.\n\n- `operator`: the ID of the tour operator that operates the tour. Operator IDs can be obtained from the  **[/operators](#tag/Operators/paths/~1v1~1operators/get)** endpoint.\n- `currency`: the prices will be returned in the specified currency. Use 3 letter codes, example: `AUD`, `EUR`, `USD`.\n- `start_city`: the ID for the start city of the tour. City IDs can be obtained from the **[/taxonomy/destinations/city](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.\n- `end_city`: the ID for the end city of the tour. City IDs can be obtained from the same endpoint mentioned before.\n- `city`: the ID for any city included on the tour itinerary. City IDs can be obtained from the same endpoint mentioned before. Multiple values are allowed, if you are looking for tours that have in itinerary both London and Paris you can make the call `GET /tours/search?city=11149&city=5781`. If you need tours that have in itinerary either London or Paris you can make the call `GET /tours/search?city=11149%2C5781`.\n- `country`: the ID for any country included on the tour itinerary. Country IDs can be obtained from the **[/taxonomy/destinations/country](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.\n- `user_country`: the ID for the country of the passenger's residence. Country IDs can be obtained from the same endpoint mentioned before.\n- `primary_country`: the ID for the country in which at least 2/3rd of the tour destinations are located. Country IDs can be obtained from the **[/taxonomy/destinations/country](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.\n- `continent`: the ID for any continent included on the tour itinerary. Continent IDs can be obtained from the **[/taxonomy/destinations/continent](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.\n- `natural_destination`: the ID for any natural destination included on the tour itinerary. Natural destination IDs can be obtained from **[/taxonomy/destinations/{type}](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint (type can be `mountain`, `national_park`, `river`, etc).\n- `age`: age range the tour is suitable for, expressed as _min-max_. Using this parameter, all tours that include the desired range will be returned. For example, if `age=18-35`, tours that accepts from 18 to 60 years old will be included in the search result. To only search for an exact age range, use the parameter `exact_age` instead.\n- `exact_age`: exact age range the tour is suitable for, expressed as _min-max_ or just _max_. Example: `12-40` meaning the tour is suitable for and accepts 12 to 40 years old passengers.\n- `duration`: tour duration in numbers of days, expressed as _min-max_. Example: `5-7` meaning tours between 5 and 7 days of duration.\n- `date_range`: range of the desired departure date, expressed as _min-max_. For dates, use the format `YYYYMMDD`, where `YYYY` is the year, `MM` the month, `DD` the day. Example: `20211001-20211030` meaning tours departing in November 2021 (2021-11-01 to 2021-11-30).\n- `price`: desired price range for the tour, expressed as _min-max_. Example: `1000-1500` meaning tours between 1000 and 1500 units (in the currency specified by the `currency` parameter).\n- `price_per_day`: same as `price`, but using the price per day as value.\n- `group_size`: maximum desired group size. Example: `10` will only return tours with a maximum group size of 10 persons.\n- `guide_language`: the ID of the language the tour is operated in. Language IDs can be obtained from the **[/taxonomy/languages](#tag/Taxonomy/paths/~1v1~1taxonomy~1languages/get)** endpoint.\n- `tour_type`: the ID of the tour type you would like to use as a filter. Tour type IDs can be obtained from the **[/taxonomy/tours/types](#tag/Taxonomy/paths/~1v1~1taxonomy~1tours~1types/get)** endpoint. For example, looking at the taxonomy endpoint, the tour type **Sightseeing** has ID 76. If you want to search for tours with this type, the request will look like this: `GET /tours/search?tour_type=76`.\n- `is_instant_confirmable`: if true, only tours that can be automatically confirmed will be returned, if false only non instant confirmable.\n- `fields`: using this parameter it's possible to restrict the number of fields in the response. Use field names separated by commas. For example, the request `GET /tours/search?fields=tour_id,tour_name,operator` will return just the tour_id, tour_name and operator.\n\n#### Sorting\n\nYou can get the results sorted by passing some additional parameters:\n- `sort_by`: one of `score`, `price`, or `price_per_day`.\n- `sort_order`: `asc` or `desc` for ascending or descending sort order.\n\nThe default sort order, if not specified, is by popularity (`score`).\n\n\n#### Pagination\n\nThe search endpoints returns 20 results at a time.\n\nIf the response contains the `next_page` element, it's possible to access the next 20 elements by repeating the request with the `page` parameter.\n\nThe `limit` parameter can be used to change the number of results per page from the default of 20.\n\n#### Example\n\nA full example of a call to this endpoint could be:\n\n```\nGET /tours/search?country=84&tour_type=7&operator=3086&limit=1&page=1\n```\n\nAdditional parameters may be added in a future revision.\n\n#### Output definition\n\nThe list of tours is contained in the `items` array.\n\nThe data for each tour will include the ID, the name, images, list of destinations, and categorization.\n\nTo retrieve more detailed content about the tour, including itinerary and services, the tour identifier can be used for the **[/tours/{tourId}](#tag/Tours/paths/~1v1~1tours~1{tourId}/get)** endpoint.\n","parameters":[{"name":"exact_age","in":"query","description":"Exact age range the tour is suitable for, expressed as _min-max_ or just _max_. The tour is returned only if its age range exactly matches the input values.","schema":{"type":"string"}},{"name":"start_city","in":"query","description":"The ID for the start city of the tour.","schema":{"type":"string"}},{"name":"primary_country","in":"query","description":"The ID for the country in which at least 2/3rd of the tour destinations are located.","schema":{"type":"string"}},{"name":"price_per_day","in":"query","description":"Desired tour price per day range, expressed as _min-max_.","schema":{"type":"string"}},{"name":"city","in":"query","description":"The ID for any city included on the tour itinerary.","schema":{"type":"string"}},{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"sort_order","in":"query","description":"Direction of the sorting (ascending or descending). Possible values: `asc`, `desc`.","schema":{"type":"string"}},{"name":"tour_type","in":"query","description":"The ID of the tour type you would like to use as a filter.","schema":{"type":"string"}},{"name":"limit","in":"query","description":"Number of items per page of results (default is 20).","schema":{"type":"string"}},{"name":"natural_destination","in":"query","description":"The ID for any natural destination included on the tour itinerary.","schema":{"type":"string"}},{"name":"continent","in":"query","description":"The ID for any continent included on the tour itinerary.","schema":{"type":"string"}},{"name":"sort_by","in":"query","description":"Field by which the results will be sorted. Possible values: `score`, `price`, `price_per_day`. Default is `score`, a measure of the tour popularity.","schema":{"type":"string"}},{"name":"age","in":"query","description":"Age range the tour is suitable for, expressed as _min-max_. Using this parameter, all tours that include the desired range will be returned. For example, if `age=18-35`, tours that accepts from 18 to 60 years old will be included in the search result. To only search for an exact age range, use the parameter `exact_age` instead.","schema":{"type":"string"}},{"name":"duration","in":"query","description":"Tour duration in numbers of days, expressed as _min-max_.","schema":{"type":"string"}},{"name":"group_size","in":"query","description":"Maximum desided group size.","schema":{"type":"string"}},{"name":"currency","in":"query","description":"The currency desired for the prices returned. Use 3 letter codes, like `AUD`, `EUR`, `USD`, etc. ","schema":{"type":"string"}},{"name":"user_country","in":"query","description":"The ID for the country of the passenger's residence.","schema":{"type":"string"}},{"name":"date_range","in":"query","description":"Range of the desired departure date, expressed as _min-max_.","schema":{"type":"string"}},{"name":"guide_language","in":"query","description":"The ID of the language the tour is operated in.","schema":{"type":"string"}},{"name":"end_city","in":"query","description":"The ID for the end city of the tour.","schema":{"type":"string"}},{"name":"price","in":"query","description":"Desired tour price range, expressed as _min-max_.","schema":{"type":"string"}},{"name":"country","in":"query","description":"The ID for any country included on the tour itinerary.","schema":{"type":"string"}},{"name":"operator","in":"query","description":"The ID of the tour operator that operates the tour.","schema":{"type":"string"}},{"name":"is_instant_confirmable","in":"query","description":"If true will only return tours that can be automatically confirmed, if false only tours that cannot be instantly booked.","schema":{"type":"string"}},{"name":"page","in":"query","description":"Number of page to return (default is 1).","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ToursListPagination"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.tours/read"]}]}},"/v1/tours/{tourId}":{"get":{"tags":["Tours"],"summary":"/v1/tours/{tourId}","description":"\nReturns detailed information about a single tour.\n\nThe call expects one parameter as part of the request path, the unique identifier of the tour in the TourRadar system.\n\nTo retrieve a list of tour identifiers, use the **[/tours/search](#tag/Tours/paths/~1v1~1tours~1search/get)** endpoint.\n\n#### Output definition\n\nIt should be noted that the following identifiers are present:\n\n| field | notes |\n| ----- | ----- |\n| `tour_id` | TourRadar identifier for the tour, always present and unique across all tours from all tour operators. |\n| `codes` | Identifiers provided by the tour operator for the tour. It can be null, and codes might not be unique. |\n","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"currency","in":"query","schema":{"type":"string"}},{"name":"user_country","in":"query","schema":{"type":"string"}},{"name":"tourId","in":"path","description":"Tour's unique ID.","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Tour"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"Tour not found. Please check tour ID.","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["TOUR_NOT_FOUND","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.tours/read"]}]}},"/v1/tours/{tourId}/departures":{"get":{"tags":["Pricing & Availability"],"summary":"/v1/tours/{tourId}/departures","description":"Retrieves all available departure dates for the specified tour.\n\nEvery item will contain:\n\n* Departure date, in the format `YYYY-MM-DD`.\n* Departure type, as explained below.\n* Guide languages offered.\n* The price breakdown, using the *default* options for each departure date, comprised of:\n  * `price_base`: base price of the tour, also referenced as brochure price.\n  * `price_addons`: sum of the mandatory addons that the passenger will have to pay (both upfront and local payments).\n  * `price_promotion`: discounted price, it’s equal with price_base – promotion discount.\n  * `price_total_upfront`: total price without local payments, it’s equal with price_base – promotion discount + upfront payments.\n  * `price_total`: final sale price, it’s equal with price_base – promotion discount + local payments + upfront payments.\n  * `promotion`: details about the promotion applied, if available.\n  * `mandatory_addons`: list of the mandatory addons (upfront and local payments). \n  \n#### Departure types\n\nA departure date can have one of the following types:\n\n* `guaranteed`: the tour will depart regardless of how many people books.\n* `scheduled`: the tour will depart provided that a suitable minimum number of participants is reached. Confirmation will be given usually 4-6 weeks before the travel date.\n* `request`: if a tour is close to departure, or almost at capacity, the tour operator cannot immediately guarantee all the components of the tour are available to book (accommodation, activities, etc.).\n","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"currency","in":"query","description":"The currency desired for the prices returned. Use 3 letter codes, like `AUD`, `EUR`, `USD`, etc.","schema":{"type":"string"}},{"name":"page","in":"query","description":"Number of page to return (default is 1).","schema":{"type":"string"}},{"name":"user_country","in":"query","description":"Country ID of the passenger's residence, if known. This will be used to apply location-specific promotions, e.g. particular discounts that are available only to some markets. To retrieve the country IDs, use the **[/taxonomy/destinations/country](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.","schema":{"type":"string"}},{"name":"tourId","in":"path","description":"The ID of the tour for which departure dates are to be returned.","required":true,"schema":{"type":"string"}},{"name":"date_range","in":"query","description":"If provided, returns only departure dates in the desired range. Format is `YYYYMMDD-YYYYMMDD`, where `YYYY` is the year, `MM` the month, `DD` the day. Example: `20211001-20211030` searches for departure dates in November 2021 (2021-11-01 to 2021-11-30).","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TourDeparturesPagination"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"Tour not found. Please check tour ID.","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["TOUR_NOT_FOUND","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.tours/read"]}]}},"/v1/tours/{tourId}/departures/{departureId}":{"get":{"tags":["Pricing & Availability"],"summary":"/v1/tours/{tourId}/departures/{departureId}","description":"Retrieve detailed information about a single departure date.\n\nIn addition to the information returned when listing departure dates, this endpoint will include:\n\n* accommodation options\n* mandatory addons\n* optional extras\n\nFor each element, all available price categories (adult, child, etc.) will be returned.\n\nTo get a list of available price categories, and their properties, use the **[/tours/{tourId}/prices](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1prices/get)** endpoint.","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"currency","in":"query","description":"The currency desired for the prices returned. Use 3 letter codes, like `AUD`, `EUR`, `USD`, etc.","schema":{"type":"string"}},{"name":"user_country","in":"query","description":"Country ID of the passenger's residence, if known. This will be used to apply location-specific promotions, e.g. particular discounts that are available only to some markets. To retrieve the country IDs, use the **[/taxonomy/destinations/country](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.","schema":{"type":"string"}},{"name":"tourId","in":"path","description":"The ID of the tour.","required":true,"schema":{"type":"string"}},{"name":"departureId","in":"path","description":"The ID of the departure date.","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TourDeparture"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"Departure not found. Please check tour ID and departure ID.","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["TOUR_NOT_FOUND","TOUR_DEPARTURE_NOT_FOUND","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.tours/read"]}]}},"/v1/tours/{tourId}/departures/{departureId}/price":{"post":{"tags":["Pricing & Availability"],"summary":"/v1/tours/{tourId}/departures/{departureId}/price","description":"Calculates the price for a booking, given departure date, number and type of passengers, and selected options.\n\nThe payload must be sent as a JSON in the request body.\nThe required entries are:\n\n* `currency`: the currency that will be used for payments.\n* `passengers`: the list of passengers in the booking.\n\nFurthermore, it's possible to add the following sections, if needed:\n\n* `accommodations`: defines the desired accommodation types (if the tour offers them), and which passengers will use them.\n* `optional_extras`: optional extra items that can be booked together with the tour.\n\nThis is an example of how the payload for a price calculation request looks like:\n\n```json\n{\n  \"currency\": \"EUR\",\n  \"passengers\": [\n    {\n      \"pax_number\": 1,\n      \"price_category_id\": 1\n    },\n    {\n      \"pax_number\": 2,\n      \"price_category_id\": 2\n    }\n  ],\n  \"accommodations\": [\n    {\n      \"id\": 345,\n      \"passengers\": [1, 2]\n    }\n  ],\n  \"optional_extras\": [\n    {\n      \"id\": 456,\n      \"passengers\": [2]\n    }\n  ],\n}\n```\n\n#### Passengers definition\n\nFor each entry in the `passengers` array, these are the required fields:\n\n* `pax_number`: this is the index of the passenger, starting with 1. The passenger number will be used in the accommodation and extras sections of the request, to assign specific passengers to elements of the booking.\n* `price_category_id`: this defines the category of the passenger. To retrieve price categories, use the **[/tours/{tourId}/prices](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1prices/get)** endpoint.\n\n#### Accommodation\n\nIn the `accommodations` section, it's possible to specify the identifier of an accommodation option, and which passenger numbers should make use of it.\n\nTo retrieve a list of accommodation options available for the desired departure, use the **[/tours/{tourId}/departures/{departureId}](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures~1{departureId}/get)** endpoint.\n\n#### Optional extras\n\nThe `optional_extras` section works exactly like the `accommodations` section.\n\nTo retrieve a list of the optional extra items available for the desired departure, use the **[/tours/{tourId}/departures/{departureId}](#tag/Pricing-and-Availability/paths/~1v1~1tours~1{tourId}~1departures~1{departureId}/get)** endpoint.\n\n#### Response\n\nThe response will contain a price breakdown:\n\n  * `price_base`: base price of the tour, also referenced as brochure price.\n  * `price_addons`: sum of the mandatory addons that the passenger will have to pay (both upfront and local payments).\n  * `price_promotion`: discounted price, it’s equal with price_base – promotion discount.\n  * `price_total_upfront`: total price without local payments, it’s equal with price_base – promotion discount + upfront payments. This is the actual price that the customer needs to pay when making a booking.\n  * `price_total`: final sale price, it’s equal with price_base – promotion discount + local payments + upfront payments. This contains the price that customer needs to pay and the local payments that will be paid in cash on the tour.\n  * `promotion`: details about the promotion applied, if available.\n  * `mandatory_addons`: list of the mandatory addons (upfront and local payments). \n\nLocal payments are shared with the customer before making the booking but they are paid only when they reach the destination, in cash.\nUpfront payments are mandatory payments made at the time of the booking.","parameters":[{"name":"Accept-Language","in":"header","schema":{"type":"string"}},{"name":"currency","in":"query","description":"The currency desired for the prices returned. Use 3 letter codes, like `AUD`, `EUR`, `USD`, etc.","schema":{"type":"string"}},{"name":"user_country","in":"query","description":"Country ID of the passenger's residence, if known. This will be used to apply location-specific promotions, e.g. particular discounts that are available only to some markets. To retrieve the country IDs, use the **[/taxonomy/destinations/country](#tag/Taxonomy/paths/~1v1~1taxonomy~1destinations~1{type}/get)** endpoint.","schema":{"type":"string"}},{"name":"tourId","in":"path","description":"The ID of the tour.","required":true,"schema":{"type":"string"}},{"name":"departureId","in":"path","description":"The ID of the departure date.","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TourDeparturePriceInput"}}},"required":true},"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TourDeparturePrice"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"Departure not found. Please check tour ID and departure ID.","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["TOUR_NOT_FOUND","TOUR_DEPARTURE_NOT_FOUND","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.tours/read"]}]}},"/v1/tours/{tourId}/prices":{"get":{"tags":["Pricing & Availability"],"summary":"/v1/tours/{tourId}/prices","description":"Retrieves all price categories available for a tour.\n\nPrice categories correspond to passenger types. \nThose are configured by the operator for each tour, and may vary for different tours.\nThe main categories recognised by the TourRadar system are:\n\n* `adult`\n* `child`\n* `infant` (usually don't count towards max occupancy)\n* `senior`\n* `student`\n* `military`\n* `other`\n\nThe age limits, if any, are returned by this endpoint for all configured price categories.\n","parameters":[{"name":"tourId","in":"path","description":"The ID of the tour for which price categories are to be returned.","required":true,"schema":{"type":"string"}},{"name":"Accept-Language","in":"header","schema":{"type":"string"}}],"responses":{"200":{"description":"200 response","content":{"application/json":{"schema":{"$ref":"#/components/schemas/TourPriceCategories"}}}},"401":{"description":"This status code indicates that the credentials used for the request are not valid.\n\nThe error code is `UNAUTHORIZED`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- invalid authorization token\n- operation not allowed by authorization scope\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError401"}}}},"404":{"description":"Tour not found. Please check tour ID.","content":{"application/json":{"schema":{"type":"object","properties":{"error":{"type":"string","description":"The error code","enum":["TOUR_NOT_FOUND","UNKNOWN_ERROR"]},"message":{"type":"string","description":"The error message, if available"},"context":{"type":"object","description":"Additional data relative to the error condition"},"validation_errors":{"type":"array","description":"In case of validation error, all the elements that didn't pass validation","items":{"type":"string"}}}}}}},"500":{"description":"This status code indicates that there was an unmanaged error.\n\nThe error code is `UNKNOWN_ERROR`. An additional message may provide more information about the error.\n\nCauses for this error may be:\n\n- failure on the TourRadar system\n- unexpected conditions\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/DefaultError500"}}}}},"security":[{"application":["com.tourradar.tours/read"]}]}}},"components":{"schemas":{"PartnerAdminMergePartnerOutput":{"type":"object","required":["message"],"properties":{"message":{"type":"string","description":"Amount of moved users","example":"10 users were moved to partner tourradar"}}},"PartnersDomainInput":{"type":"object","required":["type","subdomain","host"],"properties":{"type":{"type":"string","description":"The type of the partner domain","enum":["whitelabel","agent-portal","shop"],"example":"whitelabel"},"subdomain":{"type":"string","enum":["whitelabel","travel","trips","explore","agents","secure"],"description":"The subdomain part of the domain partner","example":"travel"},"host":{"type":"string","description":"The host part of the domain partner, ideally same as the partner ID, but can be different. [a-z0-9-]","example":"llama-travel"}}},"OperatorCredentialsSchema":{"type":"object","description":"Schema of credentials response.","properties":{"$schema":{"type":"string","example":"http://json-schema.org/draft-04/schema#"},"title":{"type":"string","description":"Name of operator","example":"Travcorp credentials"},"type":{"type":"string","example":"array"},"items":{"type":"object","properties":{"properties":{"type":"object","properties":{"currency":{"type":"string","example":"eur"}},"additionalProperties":{"type":"object","properties":{"type":{"type":"string","example":"string"}}}},"required":{"type":"array","description":"List of required fields","items":{"type":"string","example":"currency"}},"type":{"type":"string","example":"object"}}}}},"ToursPromotion":{"type":["object","null"],"description":"Details about the promotion applied, if available.","properties":{"id":{"type":"integer","description":"Unique identifier of the promotion in the TourRadar system.","example":9990067},"discount":{"type":"number","description":"Amount of the promotion (to subtract from the base price).","example":845},"name":{"type":"string","description":"Promotion name.","example":"Special deal"},"type":{"type":"string","description":"Type of the promotion (percentage discount, or 2-for-1 offer).","example":"discount"},"percentage":{"type":["number","null"],"description":"Amount of the promotion, when promotion is based on percentage discount.","example":30},"pax_restriction":{"type":["number","null"],"description":"Maximum pax number to apply this promotion. If null - no limit.","example":30},"value_type":{"type":"string","enum":["percent","absolute"],"description":"Type of the value, can be absolute or percent.","example":"percent"},"valid_to":{"type":["string","null"],"description":"Validity definition.","example":"2024-10-16"}}},"PartnerPaymentsMethods":{"type":"array","items":{"$ref":"#/components/schemas/PartnerPaymentsMethodsMethod"}},"OperatorCredentials":{"type":"object","description":"Store list credentials","properties":{"store_id":{"type":"string","description":"Store ID in your system. If not needed, use `default`.","example":"default"},"operator_store_id":{"type":"string","description":"Store ID in the operator's system.","example":"3125"},"last_checked_at":{"type":"string","description":"Validation date of the credential item in the ATOM format","example":"2021-06-25T15:08:40+02:00"},"credentials":{"type":"array","description":"List of credentials items","items":{"type":"object","properties":{"currency":{"type":"string","description":"For which currency is the credential item. If any value is empty, fallbacks to `default` credential item's value.","example":"default"},"status":{"type":"string","description":"For which currency is the credential item. If any value is empty, fallbacks to `default` credential item's value.","enum":["pending","valid","invalid"],"example":"pending"}}}}}},"PartnerInfo":{"type":"object","required":["partner","user"],"properties":{"partner":{"$ref":"#/components/schemas/Partner"},"user":{"$ref":"#/components/schemas/PartnerUser"},"scopes":{"type":"string","description":"List of allowed user scopes separated by space","example":"com.tourradar.tours/read com.tourradar.bookings/read email openid profile"}}},"TaxonomyLinks":{"type":"array","items":{"type":"object","properties":{"type":{"type":"string","description":"Type of link","example":"serp","enum":["serp"]},"url":{"type":"string","description":"URL to www.tourradar.com website","example":"https://www.tourradar.com/d/europe?utm_source=partner-12345&utm_medium=api&utm_campaign=destinations"}}}},"PartnerPaymentsMethodsMethod":{"type":"object","properties":{"address":{"type":"string","description":"Method owner address + street number","example":"USD"},"city":{"type":"string","description":"Method owner city name","example":"Vienna"},"country":{"type":"string","description":"Method owner country name","example":"AT"},"currency":{"type":"string","description":"Method currency","example":"EUR"},"customer_id":{"type":"string","description":"Payments API customer id","example":"167435518"},"default":{"type":"boolean","description":"True if method is selected as default","example":true},"email":{"type":"string","description":"Method owner email","example":"contact@tourradar.com"},"expired":{"type":"boolean","description":"True if method is expired/no active","example":true},"first_name":{"type":"string","description":"Method owner fist name","example":"Joe"},"last_name":{"type":"string","description":"Method owner last name","example":"Doe"},"id":{"type":"string","description":"Unique ID of payment","example":"cc255bd0-04a3-41e4-9130-af4202c
[...]
